<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

add_filter("mce_external_plugins", "foldio360_gavickpro_add_tinymce_plugin");
add_filter('mce_buttons_2', 'foldio360_gavickpro_register_my_tc_button');
function foldio360_gavickpro_add_tinymce_plugin($plugin_array) {
    $plugin_array['foldio_gavickpro_tc_button'] = plugin_dir_url(__FILE__) . '/js/foldio360.js'; //
    return $plugin_array;
}
function foldio360_gavickpro_register_my_tc_button($buttons) {
    array_push($buttons, "foldio_gavickpro_tc_button");
    return $buttons;
}

function wordPress_foldio360_shortcode_specific_setting_details_create_tebles() {
    global $wpdb;
    $table_name = $wpdb->prefix .'foldio360_shortcode_setting   ';

    if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
        $sql = "CREATE TABLE $table_name (
          id int(20) unsigned NOT NULL auto_increment,
          product_id varchar(100) DEFAULT NULL,
          shortcode_width varchar(50) DEFAULT NULL,
          setting_json text DEFAULT NULL,
          watermark_img_url varchar(500) DEFAULT NULL,
          watermark_img_name varchar(300) DEFAULT NULL,
          UNIQUE KEY id (id));";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );
    }
}
function save_specific_setting_data_shortcode(){
    $width = sanitize_text_field($_POST['attachment_width']);
    if ($_POST['action']){
        foreach ($_POST['attachment'] as $key => $value){
            global $wpdb;
            $product_id = $key;
            $table_name = $wpdb->prefix . 'foldio360_shortcode_setting';
            if ($width[$key]){
                $shortcode_width = $width[$key];
            }else{
                $shortcode_width = 599;
            }
            $r = $wpdb->insert($table_name, array(
                'product_id' => $product_id,
                'setting_json'=> json_encode($value),
                'shortcode_width'=> $shortcode_width,
            ));

            if ($r) {
                $r = $wpdb->insert_id;
            }
            echo esc_html($r);
        }
        wp_send_json( array( 'success' => true ) );
        wp_die( '0', 400 );
        return true;
        wp_send_json( array( 'success' => true ) );
        wp_die( '0', 400 );
    }

}

function save_update_specific_setting_data_shortcode(){
    if ($_POST['action']){
        $width =  sanitize_text_field($_POST['attachment_width']);
        foreach ($_POST['attachment'] as $key => $value){
            global $wpdb;
            $product_id = $key;

            $table_name = $wpdb->prefix . 'foldio360_shortcode_setting';
            $result = $wpdb->get_results("SELECT * FROM $table_name WHERE product_id = '$product_id'");
            if ($width[$key]){
                $shortcode_width = $width[$key];
            }else{
                $shortcode_width = 598;
            }
            if ($result){
                $r = $wpdb->update( $table_name,['setting_json'=> json_encode($value), 'shortcode_width'=>$shortcode_width,], ['product_id' => $product_id]);
            }else{
                $r = $wpdb->insert($table_name, array('product_id' => $product_id, 'setting_json'=> json_encode($value), 'shortcode_width'=> $shortcode_width,));
            }
            if ($r) {
                $r = $wpdb->insert_id;
            }
            echo esc_html($r);
        }
        wp_send_json( array( 'success' => true ) );
        wp_die();
    }
}

function prepare_data_for_insert_image_list_data($imgData,$product_id){
    global $wpdb;
    /*foreach ($_POST['attachment'] as $imgData){*/

        $img_id = sanitize_text_field($imgData['id']);
        $post_id = sanitize_text_field($_REQUEST['product_id']);
        $title = sanitize_text_field($imgData['title']) ?? '';
        $filename = sanitize_text_field($imgData['filename']) ?? '';
        $url = sanitize_text_field($imgData['url']) ?? '';
        $link = sanitize_text_field($imgData['link']) ?? '';
        $alt = sanitize_text_field($imgData['alt']) ?? '';
        $author = sanitize_text_field($imgData['author']) ?? '';
        $description = sanitize_text_field($imgData['description']) ?? '';
        $caption = sanitize_text_field($imgData['caption']) ?? '';
        $name = sanitize_text_field($imgData['name']) ?? '';
        $status = sanitize_text_field($imgData['status']) ?? '';
        $date = sanitize_text_field($imgData['date']) ?? '';
        $modified = sanitize_text_field($imgData['modified']) ?? '';
        $menuOrder = sanitize_text_field($imgData['menuOrder']) ?? '';
        $mime = sanitize_text_field($imgData['mime']) ?? '';
        $type = sanitize_text_field($imgData['type']) ?? '';
        $subtype = sanitize_text_field($imgData['subtype']) ?? '';
        $icon = sanitize_text_field($imgData['icon']) ?? '';
        $dateFormatted = sanitize_text_field($imgData['dateFormatted']) ?? '';
        $nonces_update = sanitize_text_field($imgData['nonces']['update']) ?? '';
        $nonces_delete = sanitize_text_field($imgData['nonces']['delete']) ?? '';
        $nonces_edit = sanitize_text_field($imgData['nonces']['edit']) ?? '';
        $editLink = sanitize_text_field($imgData['editLink']) ?? '';
        $meta = sanitize_text_field($imgData['meta']) ?? '';
        $authorName = sanitize_text_field($imgData['authorName']) ?? '';
        $filesizeInBytes = sanitize_text_field($imgData['filesizeInBytes']) ?? '';
        $filesizeHumanReadable = sanitize_text_field($imgData['filesizeHumanReadable']) ?? '';
        $context = sanitize_text_field($imgData['context']) ?? '';
        $height = sanitize_text_field($imgData['height']) ?? '';
        $width = sanitize_text_field($imgData['width']) ?? '';
        $orientation = sanitize_text_field($imgData['orientation']) ?? '';
        $sizes_thumbnail_height = sanitize_text_field($imgData['sizes']['thumbnail']['height']) ?? '';
        $sizes_thumbnail_width = sanitize_text_field($imgData['sizes']['thumbnail']['width']) ?? '';
        $sizes_thumbnail_url = sanitize_text_field($imgData['sizes']['thumbnail']['url']) ?? '';
        $sizes_thumbnail_orientation = sanitize_text_field($imgData['sizes']['thumbnail']['orientation']) ?? '';
        $sizes_medium_height = sanitize_text_field($imgData['sizes']['medium']['height']) ?? '';
        $sizes_medium_width = sanitize_text_field($imgData['sizes']['medium']['width']) ?? '';
        $sizes_medium_url = sanitize_text_field($imgData['sizes']['medium']['url']) ?? '';
        $sizes_medium_orientation = sanitize_text_field($imgData['sizes']['medium']['orientation']) ?? '';
        $sizes_full_url = sanitize_text_field($imgData['sizes']['full']['url']) ?? '';
        $sizes_full_height = sanitize_text_field($imgData['sizes']['full']['height']) ?? '';
        $sizes_full_width = sanitize_text_field($imgData['sizes']['full']['width']) ?? '';
        $sizes_full_orientation = sanitize_text_field($imgData['sizes']['full']['orientation']) ?? '';
        $compat_item = sanitize_text_field($imgData['sizes']['full']['orientation']) ?? '';
        $compat_meta = sanitize_text_field($imgData['sizes']['full']['orientation']) ?? '';
        $image_json = sanitize_text_field(json_encode($imgData));
        $table_name = $wpdb->prefix . 'foldio360_images_list';
        $results = $wpdb->get_results("SELECT Max(position) as position FROM ".$table_name." WHERE product_id ='$post_id'");
        $position_id = $results['0']->position+1;
        $prepare_data = array(
            'product_id' => $post_id,'position' => $position_id,'image_id' => $img_id, 'title' => $title,
            'filename' => $filename, 'url' => $url,'link' => $link, 'alt' => $alt,
            'author' => $author, 'description' => $description,'caption' => $caption, 'name' => $name,
            'status' => $status,  'date' => $date, 'modified' => $modified,
            'menuOrder' => $menuOrder, 'mime' => $mime, 'type' => $type, 'subtype' => $subtype,
            'icon' => $icon, 'dateFormatted' => $dateFormatted, 'nonces_update' => $nonces_update,
            'nonces_delete' => $nonces_delete, 'nonces_edit' => $nonces_edit, 'editLink' => $editLink,
            'meta' => $meta, 'authorName' => $authorName,'filesizeInBytes' => $filesizeInBytes,
            'filesizeHumanReadable' => $filesizeHumanReadable, 'context' => $context,
            'height' => $height,'width' => $width, 'orientation' => $orientation,
            'sizes_thumbnail_height' => $sizes_thumbnail_height,'sizes_thumbnail_width' => $sizes_thumbnail_width,
            'sizes_thumbnail_url' => $sizes_thumbnail_url,
            'sizes_thumbnail_orientation' => $sizes_thumbnail_orientation,
            'sizes_medium_height' => $sizes_medium_height, 'sizes_medium_width' => $sizes_medium_width,
            'sizes_medium_url' => $sizes_medium_url,'sizes_medium_orientation' => $sizes_medium_orientation, 'sizes_full_url' => $sizes_full_url,
            'sizes_full_height' => $sizes_full_height,'sizes_full_width' => $sizes_full_width, 'sizes_full_orientation' => $sizes_full_orientation,
            'compat_item' => $compat_item,'compat_meta' => $compat_meta,'image_json'=>$image_json,
            'product_title'=>'',
        );
        return $prepare_data;

}


function store_foldio360_images_list_data_for_shortcode($data){
    global $wpdb;
    $product_id = sanitize_text_field($_REQUEST['product_id']);
    $product = wc_get_product($product_id);
    $table_name = $wpdb->prefix . 'foldio360_images_list';
    $json_decode_images =  json_decode( html_entity_decode( stripslashes (sanitize_text_field($_POST['attachment'])) ),true );
    foreach ($json_decode_images as $imgData){
        $prepare_data = prepare_data_for_insert_image_list_data($imgData,$product_id);
        $r = $wpdb->insert($table_name,$prepare_data);
    }

    wp_die();

}

function store_and_Update_foldio360_images_list_data_for_shortcode(){
    global $wpdb;
    $table_name = $wpdb->prefix . 'foldio360_images_list';
    $post_id = sanitize_text_field($_REQUEST['product_id']);
    $results = $wpdb->get_results("SELECT id,product_id FROM ".$table_name." WHERE product_id = '$post_id'");
    $row_count = count($results);
    $loop_count = 0;
    $table_name = $wpdb->prefix . 'foldio360_images_list';
    $json_decode_images =  json_decode( html_entity_decode( stripslashes ($_POST['attachment']) ),true );
    foreach ($json_decode_images as $imgData){
        $prepare_data = prepare_data_for_insert_image_list_data($imgData,$post_id);
        if ($loop_count  < $row_count){
            $r = $wpdb->update( $table_name,$prepare_data, ['id' => $results[$loop_count]->id]);
        } else {
            $r = $wpdb->insert($table_name,$prepare_data);
        }
        $loop_count++;
    }
    wp_die();
}

function get_shortcode_specigic_setting_details($post_id){
    global $wpdb;
    $table_name = $wpdb->prefix . 'foldio360_shortcode_setting';
    $product_id = $post_id;
    $sql = $wpdb->get_results("SELECT * FROM $table_name WHERE product_id = '$product_id'");
    $setting_data = $sql[0]->setting_json;
    $width = $sql[0]->shortcode_width;
   // $watermark_img_url = $sql[0]->watermark_img_url;
    //$watermark_img_name = $sql[0]->watermark_img_name;
    $watermark_img_url = get_option('foldio360_description_watermark_img_url'.$post_id);
    $watermark_img_name = get_option('foldio360_description_watermark_img_name'.$post_id);
    $return_data = ['setting_data'=>$setting_data,'width'=>$width,'watermark_img_url'=>$watermark_img_url,'watermark_img_name'=>$watermark_img_name];
    return $return_data;

}

function get_image_list_for_shortcode_on_edit_page(){
    global $wpdb;
    $data_img = [];
    $table_name = $wpdb->prefix . 'foldio360_images_list';
    $product_id = $_POST['product_id'];
    $sql = $wpdb->get_results("SELECT * FROM $table_name WHERE product_id = '$product_id'");
    if ($sql){
        foreach ($sql as $value){
            $data_img[] = json_decode($value->image_json);
        }
        $images = $data_img;
    }else{
        $images = [];
    }
    $settings = get_shortcode_specigic_setting_details($product_id);
    wp_die(wp_json_encode(['images'=>$images,'setting'=>$settings['setting_data'],'width'=>$settings['width'],'watermark_img_url'=>$settings['watermark_img_url'],'watermark_img_name'=>$settings['watermark_img_name']]));
}



add_filter("mce_external_plugins", "foldio360_gavickpro_add_editor_menu_load360tinymce_plugin");
add_filter('mce_buttons_2', 'foldio360_gavickpro_register_editor_menu_load360_button');
function foldio360_gavickpro_add_editor_menu_load360tinymce_plugin($plugin_array) {
    $plugin_array['foldio_gavickpro_editor_menu_load360_button'] = plugin_dir_url(__FILE__) . '/js/foldio360.js'; //
    return $plugin_array;
}
function foldio360_gavickpro_register_editor_menu_load360_button($buttons) {
    array_push($buttons, "foldio_gavickpro_editor_menu_load360_button");
    return $buttons;
}

function foldio360_shortcode_product_search(){
    global $wpdb;
    $table_name = $wpdb->prefix . 'foldio360_images_list';

    $term = strtolower($_GET['term']);

    $suggestions = array();
    if (strlen($term)>2){
        //$sql = $wpdb->get_results("SELECT * FROM $table_name WHERE product_title LIKE '%$term%' group by product_id");
        $sql = $wpdb->get_results("SELECT * FROM $table_name WHERE product_title LIKE '%$term%' AND product_id in ( SELECT `id` FROM `wp_posts` WHERE post_status = 'publish' ) group by product_id");
        foreach ($sql as $r) {
            $suggestion['label'] = $r->product_title;
            $suggestions[] = $suggestion;
        }
        wp_reset_query();
    }else{
        $suggestion['label'] = 'Please enter 3 or more characters';
        $suggestions[] = $suggestion;
    }

    $response = json_encode( $suggestions );
    wp_die($response);
    exit();
}

function foldio360_shortcode_product_upload(){
    global $wpdb;
    $sql_data = [];
    $table_name = $wpdb->prefix . 'foldio360_images_list';
    $product_title = sanitize_text_field($_POST['product_title']);

    $sql = $wpdb->get_results("SELECT * FROM $table_name WHERE product_title = '$product_title'");
    if ($sql){
        foreach ($sql as $value){
            $sql_data[] = json_decode($value->image_json);
        }
        $result = $sql_data;
    }else{
        $result = [];
    }
    wp_die(wp_json_encode($result));
}

function foldio360_description_img_save(){
    global $wpdb;
    if(sanitize_file_name($_FILES['file']['name'])){
        $uploadedfile = isset($_FILES['file']) ? $_FILES['file'] : '';
        $upload_overrides = array( 'test_form' => false );
        $movefile = wp_handle_upload( $uploadedfile, $upload_overrides);
        $post_id =  sanitize_text_field($_POST['id']);
        if ( $movefile && ! isset( $movefile['error'] ) ) {
            $arr =[
                'url'=>$movefile['url'],
                'name'=>sanitize_text_field($_FILES['file']['name']),
                'id'=> $post_id
            ];

            $table_name = $wpdb->prefix . 'foldio360_shortcode_setting';
            //$r = $wpdb->update( $table_name,['watermark_img_url'=>'https://plugin.orangemonkie.com/wp-content/uploads/2021/08/05/8346227/조선말朝鮮말.jpg','watermark_img_name'=>'조선말朝鮮말.jpg'], ['product_id' =>$_POST['id']]);

           // $r = $wpdb->update( $table_name,['watermark_img_url'=>$movefile['url'],'watermark_img_name'=>$_FILES['file']['name']], ['product_id' =>$_POST['id']]);
            update_option('foldio360_description_watermark_img_url'.$post_id, $movefile['url']);
            update_option('foldio360_description_watermark_img_name'.$post_id, sanitize_text_field($_FILES['file']['name']));

            wp_die(wp_json_encode($arr));

        }
    }
}
?>
